function normalizeCountry(name) {
  return name
    .replaceAll(' ', '_')
    .replaceAll(',', '')
    .replaceAll('.', '')
    .replaceAll("'", '');
}

export function processRawData(rawData) {
  let data = new Map();
  rawData.forEach((row) => {
    row.countries.forEach((country) => {
      country.country = normalizeCountry(country.country);
      if (!data.has(country.country)) {
        data.set(country.country, {
          continent: country.continent,
          country: country.country,
          population: new Map(),
          life_exp: new Map(),
          income: new Map(),
        });
      }
      let countryData = data.get(country.country);
      ['population', 'income', 'life_exp'].forEach(
        (attr) => {
          countryData[attr].set(
            row.year,
            country[attr] || 0,
          );
        },
      );
    });
  });
  return data;
}
